package adapter;

import java.util.Set;
import java.util.Collection;
import java.util.List;
import java.util.Iterator;
import java.util.ListIterator;

public class SetAdapter
implements Set
{
	ListAdapter la = new ListAdapter();
	MapAdapter ma = new MapAdapter();

	public SetAdapter()
	{
	}

	public boolean add(Object o)
	{
		if(ma.containsKey(o))
		{
			return false;
		}

		ma.put(o, o);
		la.add(o);
		return true;
	}

	public boolean addAll(Collection c)
	{
		boolean retval = false;
		Iterator iter = c.iterator();
		while(iter.hasNext())
		{
			retval = retval || add(iter.next());
		}
		return retval;
	}

	public void clear()
	{
		ma.clear();
		la.clear();
	}

	public boolean contains(Object o)
	{
		return ma.containsKey(o);
	}

	public boolean containsAll(Collection c)
	{
		Iterator iter = c.iterator();
		while(iter.hasNext())
		{
			//if(!ma.containsKey(iter.next()))
			if(!contains(iter.next()))
			{
				return false;
			}
		}
		return true;
	}

	public int hashCode()
	{
		return la.hashCode();
	}

	public boolean isEmpty()
	{
		return la.isEmpty();
	}

	public Iterator iterator()
	{
		return la.iterator();
	}

	public boolean remove(Object o)
	{
		Object tmp = ma.remove(o);
		if(tmp != null)
		{
			if(!la.remove(o))
			{
				System.err.println("Mappa inconsistente con Lista: Set in stato instabile");
				//System.exit(1);
				throw new RuntimeException("AARRGGHH!! Set inconsistente");
			}
			return true;
		}
		return false;
	}

	public boolean removeAll(Collection c)
	{
		boolean retval = false;
		Iterator iter = c.iterator();
		while(iter.hasNext())
		{
			retval = retval || remove(iter.next());
		}
		return retval;
	}

	public boolean retainAll(Collection c)
	{
		ListAdapter tmp = new ListAdapter();
		tmp.addAll(la);
		tmp.removeAll(c);
		boolean retval = !tmp.isEmpty();
		Iterator iter = tmp.iterator();
		while(iter.hasNext())
		{
			remove(iter.next());
		}
		return retval;

		/*
		boolean retval = false;
		ListIterator li = la.listIterator();
		while(li.hasNext())
		{
			Object tmp = li.next();
			if(!c.contains(tmp))
			{
				li.remove();
				ma.remove(tmp);
				retval = true;
			}
		}
		return retval;
		*/
	}

	public int size()
	{
		return la.size();
	}

	public Object[] toArray()
	{
		return la.toArray();
	}

	public Object[] toArray(Object[] o)
	{
		return la.toArray(o);
	}

	public String toString()
	{
		//return la.toString();
		return la.toString() + "\n" + ma.toString();
	}
}
