package composite;

import java.util.*;

public class BoundedCanvas
implements Container
{
	List<Drawable> elements = null;
	int bound;

	public BoundedCanvas(int boundVal)
	{
		elements = new ArrayList<Drawable>(boundVal);
		bound = boundVal;
	}

	public void draw()
	{
		System.out.println("Io sono un bounded canvas[" + bound + "] e contengo:");
		ListIterator<Drawable> li = elements.listIterator();
		while(li.hasNext())
		{
			System.out.print("\t");
			li.next().draw();
		}
	}

	public boolean compose(Drawable elem)
	{
		if(elements.size() >= bound)
		{
			return false;
		}
		elements.add(elem);
		return true;
	}
}
